Skip to main content

Longest Increasing Subsequence - Part 2 - Hard

As promised, this is the follow up to the first posted earlier that there was a more efficient algorithm for finding the longest increasing subsequence, better than the O(n^2) DP solution we came up with.

It's not easy to understand, but once you get what the variables mean, it seems pretty straight forward. We'll be implementing another DP solution, similar to the previous one, except with an additional data structure that'll reduce the overall complexity to O(nlogn).

The wikipedia seems no help. The explanation is contrived and not easy to visualize. Hope this post will clear a lot of doubts. So we need 3 arrays for solving an instance of LIS.

M[i] - where M[i] is the minimum ending element of a increasing subsequence of length i. This is the key part of the new algorithm. Unlike the earlier solution where we kept the longest length discovered at index i , we store an Array which holds the minimum value of a subsequence of length i.

I[i] - where M[i] = A[I[i]] simply put, its the index of M[i] in the input Array. The length will be the same as M[i]. Both increase in size together. To define it, I[i] is the index of the minimum ending element of an increasing subsequence of length i. 

P[i] - where P[i] is the index of the previous member of the longest subsequence. It's for reconstructing the subsequence. You don't need this, if you're only interested in the length of the subsequence.

Initially, M[0] = 0 (or Integer.MIN_VALUE) and I[0] = -1 because a zero length subsequence is kind of a null set.

So the algorithm goes like this


  1.  For i = 0 to n - 1
  2. j = binarySearch(M, A[i]) #Such that M[j-1] < A[i] < M[j]
  3. M[j] = A[i]
  4. I[j] = i
  5. P[i] = I[j-1] #The index of the subsequence of the length j 
Very well, what does it all mean, though?

Ok, so lets understand the motivation behind the M[] array. Whenever we have a new element A[i], we try to "place it" at the end of  the longest increasing subsequence we have encountered yet without breaking the increasing property. But where do I place it?  Since A[i] is the last element we have seen so far, there is no other place but the end of the known subsequences. If you decide to insert A[i] into an earlier position, though the subsequence will be legal, it wouldn't be optimal.  The M[] array is basically keeping track of len(M) increasing subsequences at any time. So A[i] can be appended to one of them, the best one is the subsequence of length j where M[j-1] < A[i] < M[j].

Clearly, we can't extend the subsequence of length j since M[j] > A[i] (it wouldn't be increasing otherwise). We could insert A[i] into a subsequence of length k < j, but that wouldn't be the optimal one. So instead we're going to modify the existing subsequence of length j so that the last element is A[i] instead of a previously occurring element. At this point we're going to assign M[j] = A[i].  What this effectively means is that, we have discovered a increasing subsequence of length j that ends with A[i]. If we ever wanted to extend a subsequence ie, insert M[j+1] it has to be at least M[j] (ie A[i])

Notice when we're inserting or replacing elements in M[]  we are creating a sorted array. So we can run a binary search on the array. Here's the O(logn) component of the algorithm.

Assigning I[j] = i, is pretty straightforward, we simply remember the index of the new element in M[]. 

P[i] = I[j - 1], this requires an explanation. Remember the P[] array holds the index of the previous member of the increasing subsequence. So if I have just inserted/replaced the last element of a subsequence of length j, the previous element is the last element of the optimal increasing subsequence of length j - 1, which is conveniently I[j - 1]. Finally we simply backtrack the P array to obtain the subsequence in reverse order.


Full source code here.

Comments

Popular posts from this blog

Find Increasing Triplet Subsequence - Medium

Problem - Given an integer array A[1..n], find an instance of i,j,k where 0 < i < j < k <= n and A[i] < A[j] < A[k]. Let's start with the obvious solution, bruteforce every three element combination until we find a solution. Let's try to reduce this by searching left and right for each element, we search left for an element smaller than the current one, towards the right an element greater than the current one. When we find an element that has both such elements, we found the solution. The complexity of this solution is O(n^2). To reduce this even further, One can simply apply the longest increasing subsequence algorithm and break when we get an LIS of length 3. But the best algorithm that can find an LIS is O(nlogn) with O( n ) space . An O(nlogn) algorithm seems like an overkill! Can this be done in linear time? The Algorithm: We iterate over the array and keep track of two things. The minimum value iterated over (min) The minimum increa

Merge k-sorted lists - Medium

Problem - Given k-sorted lists, merge them into a single sorted list. A daft way of doing this would be to copy all the list into a new array and sorting the new array. ie O(n log(n)) The naive method would be to simply perform k-way merge similar to the auxiliary method in Merge Sort. But that is reduces the problem to a minimum selection from a list of k-elements. The Complexity of this algorithm is an abysmal O(nk). Here's how it looks in Python. We maintain an additional array called Index[1..k] to maintain the head of each list. We improve upon this by optimizing the minimum selection process by using a familiar data structure, the Heap! Using a MinHeap, we extract the minimum element from a list and then push the next element from the same list into the heap, until all the list get exhausted. This reduces the Time complexity to O(nlogk) since for each element we perform O(logk) operations on the heap. An important implementation detail is we need to keep track

QuickSelect - Medium

Problem : Given an unsorted array, find the kth smallest element. The problem is called the Selection problem . It's been intensively studied and has a couple of very interesting algorithms that do the job. I'll be  describing an algorithm called QuickSelect . The algorithm derives its name from QuickSort. You will probably recognise that most of the code directly borrows from QuickSort. The only difference being there is a single recursive call rather than 2 in QuickSort. The naive solution is obvious, simply sort the array `O(nlogn)` and return the kth element. Infact, you can partially sort it and use the Selection sort to get the solution in `O(nk)` An interesting side effect of finding the kth smallest element is you end up finding the k smallest elements. This also effectively gives you (n - k) largest elements in the array as well. These elements are not in any particular order though. The version I'm using uses a random pivot selection, this part of the al